'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = Inject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

'use strong';

function Inject() {
  for (var _len = arguments.length, dependencies = Array(_len), _key = 0; _key < _len; _key++) {
    dependencies[_key] = arguments[_key];
  }

  return function (target) {
    var depends = aggregatParentDependencies(target, Array.from(dependencies)).map(function (v) {
      if (_lodash2['default'].isFunction(v) && v.name.match(/^([A-Z])/)) {
        return new v();
      } else {
        return v;
      }
    });
    var stringDepends = dependencies.filter(function (v) {
      return _lodash2['default'].isString(v);
    });

    var Constructor = function Constructor() {
      var args = arguments.length > 0 ? Array.from(arguments) : depends;
      if (arguments.length === stringDepends.length) {
        args = depends.map(function (v) {
          if (args.length > 0 && _lodash2['default'].isString(v)) {
            return args.shift();
          } else {
            return v;
          }
        });
      }

      target.prototype.constructor.apply(this, args);
    };

    Object.setPrototypeOf(Constructor, target);
    Constructor.prototype = Object.create(target.prototype, {
      constructor: {
        value: Constructor,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });

    Object.defineProperty(Constructor, 'name', { writable: true });
    Constructor.name = target.name;

    Constructor.$$dependencies = depends;
    Constructor.$inject = stringDepends;
    try {
      var decorators = require('angular-decorators');
      decorators.Inject.apply(decorators, _toConsumableArray(stringDepends))(Constructor);
    } catch (e) {}

    return Constructor;
  };
}

function aggregatParentDependencies(target, dependencies) {
  if ('$$dependencies' in target) {
    var depends = target.$$dependencies || [];
    depends.forEach(function (v) {
      dependencies.unshift(v);
    });

    dependencies = aggregatParentDependencies(target.prototype, dependencies);
  }

  return dependencies;
}
module.exports = exports['default'];